VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Qcards"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Qcard"
Attribute VB_Ext_KEY = "Member0" ,"Qcard"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
' defining the class name , this constant is used as
' a title of the messages handled by this class
Const CLASSNAME = "Qcards"

' definition of the card suits
Const CLUBS = 1
Const DIAMONDS = 2
Const HEARTS = 3
Const SPADES = 4
Const NULL_QCARD = -1

Private mDeck(1 To 52) As Integer ' holds the deck sequence
Private mDeckNo As Integer ' holds the deck array index
Private mCol As Collection 'holds a collection of exposed Qcards
Private pFrm As Form ' holds a pointer to the relevant form
Private bInit As Boolean ' determines if the class is initialized
Private mCardWidth As Integer ' holds the cards` width
Private mCardHeight As Integer ' holds the cards` height
Private mCardBack As Integer ' holds the cardback design used to draw the cards` back
Public Property Let CardHeight(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CardHeight = 5
    mCardHeight = vData
End Property
Public Property Get CardHeight() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CardHeight
    CardHeight = mCardHeight
End Property
Public Property Let CardBack(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CardBack = 5
If vData >= 1 And vData <= 6 Then
    mCardBack = vData
Else
     MsgBox "Back card property must be set between 1 to 6! " _
         , vbExclamation + vbOKOnly, CLASSNAME
End If
End Property
Public Property Get CardBack() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CardBack
    CardBack = mCardBack
End Property
Public Property Let CardWidth(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CardWidth = 5
    mCardWidth = vData
End Property
Public Property Get CardWidth() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CardWidth
    CardWidth = mCardWidth
End Property
'this sub deletes the collection of Qcards
Public Sub Clear()
Dim IntI As Integer

If Count <> 0 Then
    For IntI = 1 To Count
        Remove 1
    Next
End If
End Sub
'this sub initializes the Qcards dll
Public Sub Initialize(ByVal frm As Form)
Dim IntRes As Integer

'using the API function 'InitializeDeck' to initialize the Qcards dynamic link library
IntRes = InitializeDeck(frm.hWnd)

If IntRes = False Then
    MsgBox "Couldn`t load Qcard.dll!" _
         , vbExclamation + vbOKOnly, CLASSNAME
    bInit = False
    Set pFrm = Nothing
Else
    bInit = True
    Set pFrm = frm
End If

End Sub
'this function checks if the class is initialized
'it returns true if the class is initialized or ends the
'execution of the program if the class is not.
Private Function IsInit() As Boolean
If bInit Then
    IsInit = True
Else
     MsgBox "You must use initialize before calling this!" _
         , vbExclamation + vbOKOnly, CLASSNAME
    End
End If
End Function
' this sub deals a Qcard according to given qcard parameters
' nCard - the number of the Qcard
' x - x coordinate  on the form
' y - y coordinate on the form
Public Sub DealQCard(ByVal nCard As Integer, ByVal x As Single, ByVal y As Single)
Dim Qcrd As New Qcard

'checks if the class is initialized
IsInit

'checks the nCard parameter is valid
If nCard < 1 Or nCard > 113 Then
    MsgBox "Invalid use of DealQcard!" _
         , vbExclamation + vbOKOnly, CLASSNAME
    Exit Sub
End If

'using the API function 'DealCard' to draw the Qcard on the form
DealCard pFrm.hWnd, nCard, x, y
 
'setting the Qcard object attributes
Qcrd.x = x
Qcrd.y = y
Qcrd.nCard = nCard

'adding the Qcard object to the exposed Qcards collection
'using the nCard parameter as a key string that can be used,
'to access a member of the collection.
Add Qcrd, CStr(nCard)
End Sub
'this sub paints the Qcards collection on the relevant form
'using the API functions 'DrawBack' and 'DealCard'
Public Sub Paint()
Dim Qcrd As New Qcard

'checks if the class is initialized
IsInit

For Each Qcrd In mCol
    If Not Qcrd.Visible Then
'if the card is not visible then draw the cardback design
        DrawBack pFrm.hWnd, mCardBack, Qcrd.x, Qcrd.y
    Else
'if the card is visible then draw it on the form
        DealCard pFrm.hWnd, Qcrd.nCard, Qcrd.x, Qcrd.y
    End If
Next

End Sub
'this sub randomizes a pack of qcards used to deal random card
'from the pack
Private Sub RndPack()
Dim IntI, IntJ, IntK As Integer

'initialization of the mDeck array
For IntI = 1 To 52
    mDeck(IntI) = IntI
Next

Randomize
For IntI = 1 To 10
    For IntJ = 1 To 52
        IntK = (Int(Rnd * 52) + 1) 'returns and integer number between 1-52
        ' swapping between the two numbers
        Temp = mDeck(IntJ)
        mDeck(IntJ) = mDeck(IntK)
        mDeck(IntK) = Temp
    Next
Next
mDeckNo = 1 ' setting the mDeck index to the beginning of the array
End Sub
'this function deals a random Qcard from the Qcards pack ,draws
'it on the form and adds it to the exposed qcards collection
' x - x coordinate  on the form
' y - y coordinate on the form
' visible - determines how the card will be drawn on the form
' returned value - a refernce to the Qcard object dealt
Public Function DealRndQCard(ByVal x As Single, ByVal y As Single, Optional Visible As Boolean = True) As Qcard
Dim Qcrd As New Qcard
Dim nCard, IntTry As Integer

'checks if the class is initialized
IsInit

Do
'if the mDeck index is at the end of the array then randomize the deck
    If mDeckNo = 53 Then RndPack
'pick a card number from the deck and set the mDeck index to the next card number
    nCard = mDeck(mDeckNo)
    mDeckNo = mDeckNo + 1
'error handler routine prevents a dead lock in the do..while statement
    If IntTry = 500 Then
         MsgBox "Error in DealRndQCard!" _
         , vbExclamation + vbOKOnly, CLASSNAME
        Exit Function
    End If
    IntTry = IntTry + 1
'loop until the card chosen is not exposed on the form
Loop While IsInQcards(CStr(nCard))

'draws the qcard on the form according to it`s visibility
If Not Visible Then
    DrawBack pFrm.hWnd, mCardBack, x, y
Else
    DealCard pFrm.hWnd, nCard, x, y
End If


'sets the qcard`s attributes
Qcrd.x = x
Qcrd.y = y
Qcrd.nCard = nCard
Qcrd.Visible = Visible

'adding the Qcard object to the exposed Qcards collection
'using the nCard variable as a key string that can be used,
'to access a member of the collection.
Set DealRndQCard = Add(Qcrd, CStr(nCard))
pFrm.Text1 = pFrm.Text1 + 1
'pFrm.Text1 = Count


End Function
'this sub draws a deck on a form
' xLoc - x coordinate of the drawn pack
' yLoc - y coordinate of the drawn pack
' nCardBack - the backcard design used to draw the pack
Public Sub DrawPack(xLoc As Single, yLoc As Single, Optional nCardBack As Integer)
Dim IntI As Integer

'checks if the class is initialized
IsInit

For IntI = 1 To 6
'if the nCardBack parameter is missing then use the cardback property value
    If nCardBack = 0 Then
        DrawBack pFrm.hWnd, mCardBack, xLoc + 2 * IntI, yLoc - 2 * IntI
    ElseIf nCardBack >= 1 And nCardBack <= 6 Then
        DrawBack pFrm.hWnd, nCardBack, xLoc + 2 * IntI, yLoc - 2 * IntI
    Else
        MsgBox "Back card value must be set between 1 to 6! " _
         , vbExclamation + vbOKOnly, CLASSNAME
        Exit For
    End If
Next
End Sub
'this function checks if a given key string is in the Qcards collection
'StrnCard - key string searched
Public Function IsInQcards(StrnCard As String) As Boolean
Dim Qcrd As New Qcard

'checks if the class is initialized
IsInit


'the item function returns a Qcard object which corresponds to
'the given key string or a Qcard object with nCard attribute
'set to -1 in case the item is not found
Set Qcrd = Item(StrnCard)
IsInQcards = Not (Qcrd.nCard = -1)
End Function

'this function Adds a Qcard object to the exposed qcards collection
'Qcrd - qcard object to be placed in the collection
'skey - a key string that can be used to access a member of the
'collection.
'returned value: Qcrd object
Public Function Add(Qcrd As Qcard, Optional sKey As String) As Qcard

  
    If Len(sKey) = 0 Then
        mCol.Add Qcrd
    Else
        mCol.Add Qcrd, sKey
    End If


    'return the object created
    Set Add = Qcrd
    
End Function
'this property gets a Qcard object from the Qcards collection
'vntIndexKey - contains either the Index or Key to the collection
Public Property Get Item(vntIndexKey As Variant) As Qcard
Attribute Item.VB_UserMemId = 0
Dim Qcrd As New Qcard
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
On Error Resume Next
  
Set Item = mCol(vntIndexKey)
'in case the item is not found , an error is raised
If Err.Number <> 0 Then
   Err.Clear
'setting the item returned to NULL_QCARD
   Qcrd.nCard = NULL_QCARD
   Set Item = Qcrd
End If
End Property
Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)
    mCol.Remove vntIndexKey
  '  pFrm.Text1 = Count
End Sub
'Public Property Get NewEnum() As IUnknown
   'this property allows you to enumerate
   'this collection with the For...Each syntax
'    Set NewEnum = mCol.[_NewEnum]
'End Property

'this sub is calledwhen the object is created , it sets the default
'values of the Qcard object and randomizes the pack for the
'first time
Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    bInit = False
    Set pFrm = Nothing
    mCardWidth = 71
    mCardHeight = 96
    mCardBack = 4
    RndPack
End Sub
Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

